// Dialog.cpp: _CAO֌W
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Dialog.h"
#include "resource.h"
#include "Common/StdOutStream.h"

#include "Windows/PropVariant.h"
#include "Windows/PropVariantConversions.h"
#include "Windows/FileDir.h"
#include "Common/UTFConvert.h"
#include "Common/MyCom.h"

#include <commctrl.h>

extern BOOL HandlerRoutine();

// ݂̃vZXōŌɃANeBCuEBhE擾
BOOL CALLBACK GetProcessLastActivePopup(HWND hWnd, LPARAM lParam)
{
	DWORD dwProcessId;
	::GetWindowThreadProcessId(hWnd, &dwProcessId);
	if (::GetCurrentProcessId() == dwProcessId &&
		::GetWindow(hWnd, GW_OWNER) == NULL)
	{
		HWND* phWnd= (HWND*)lParam;
		*phWnd = ::GetLastActivePopup(hWnd);
		return FALSE;
	}
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// CDialog : _CAO{NX
//////////////////////////////////////////////////////////////////////

CDialog::CDialog()
{
	m_hWnd = NULL;
	m_hWndParent = NULL;
	m_nTemplateID = 0;
	m_bLoopExit = FALSE;
}

CDialog::~CDialog()
{

}

BOOL CDialog::DialogProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	if (uMsg == WM_INITDIALOG)
	{
		((CDialog*)lParam)->m_hWnd = hDlg;
		::SetWindowLong(hDlg, GWL_USERDATA, lParam);
	}
	CDialog* pDlg = (CDialog*)::GetWindowLong(hDlg, GWL_USERDATA);
	return pDlg ? pDlg->DialogProc(uMsg, wParam, lParam) : 0;
}

BOOL CDialog::DialogProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	return 0;
}

// bZ[W[v
void CDialog::Loop()
{
	MSG msg;
	while (!m_bLoopExit && ::GetMessage(&msg, NULL, 0, 0))
	{
		if (msg.hwnd == NULL || !::IsDialogMessage(m_hWnd, &msg))
		{
			::TranslateMessage(&msg);
			::DispatchMessage(&msg);

			if (msg.hwnd == m_hWndParent && msg.message == 0)
				::PostMessage(m_hWnd, WM_CLOSE, 0, 0);
		}
	}
	m_bLoopExit = FALSE;
}

// EBhEeEBhE̒SɈړ
void CDialog::MoveCenter()
{
	RECT rcOwner;
	RECT rcChild;
	RECT rcDesktop;

	::GetWindowRect(m_hWndParent ? m_hWndParent : ::GetDesktopWindow(), &rcOwner);
	::GetWindowRect(m_hWnd, &rcChild);
	::SystemParametersInfo(SPI_GETWORKAREA, 0, &rcDesktop, 0);
	int x = rcChild.left + (rcOwner.left + rcOwner.right - rcChild.left - rcChild.right) / 2;
	int y = rcChild.top + (rcOwner.top + rcOwner.bottom - rcChild.top - rcChild.bottom) / 2;
	if (x < rcDesktop.left) x = rcDesktop.left;
	if (y < rcDesktop.top) y = rcDesktop.top;
	if (x + rcChild.right - rcChild.left > rcDesktop.right) x = rcDesktop.right - (rcChild.right - rcChild.left);
	if (y + rcChild.bottom - rcChild.top > rcDesktop.bottom) y = rcDesktop.bottom - (rcChild.bottom - rcChild.top);
	::SetWindowPos(m_hWnd, NULL, x, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
}

// [hX_CAOŃ[__CAO̓_CAO쐬B
BOOL CDialog::CreateModal()
{
	if (g_bIsNT)
	{
		if (!::CreateDialogParamW(g_hInstance, MAKEINTRESOURCEW(m_nTemplateID), m_hWndParent, CDialog::DialogProc, (LPARAM)this))
			return FALSE;
	}
	else
	{
		if (!::CreateDialogParamA(g_hInstance, MAKEINTRESOURCEA(m_nTemplateID), m_hWndParent, CDialog::DialogProc, (LPARAM)this))
			return FALSE;
	}
	Loop();
	return TRUE;
}

// _CAÕRg[̕ݒiWWin9xnΉ)
BOOL CDialog::SetDlgItemTextW(int nID, LPCWSTR lpszString)
{
	if (g_bIsNT)
		return ::SetDlgItemTextW(m_hWnd, nID, lpszString);
	return ::SetDlgItemTextA(m_hWnd, nID, GetOemString(lpszString));
}

// _CAÕRg[̕擾iWWin9xnΉ)
int CDialog::GetDlgItemTextW(int nID, UString& rString)
{
	rString.Empty();
	if (g_bIsNT)
	{
		int nLen = ::GetWindowTextLengthW(::GetDlgItem(m_hWnd, nID));
		if (nLen)
		{
			++nLen;
			::GetDlgItemTextW(m_hWnd, nID, rString.GetBuffer(nLen), nLen);
			rString.ReleaseBuffer();
		}
	}
	else
	{
		AString string;
		int nLen = ::GetWindowTextLengthA(::GetDlgItem(m_hWnd, nID));
		if (nLen)
		{
			++nLen;
			::GetDlgItemTextA(m_hWnd, nID, string.GetBuffer(nLen), nLen);
			string.ReleaseBuffer();
		}
		rString = GetUnicodeString(string);
	}
	return rString.Length();
}

// [__CAO쐬
int CDialog::DoModal()
{
	if (g_bIsNT)
		return ::DialogBoxParamW(g_hInstance, MAKEINTRESOURCEW(m_nTemplateID), m_hWndParent, CDialog::DialogProc, (LPARAM)this);
	return ::DialogBoxParamA(g_hInstance, MAKEINTRESOURCEA(m_nTemplateID), m_hWndParent, CDialog::DialogProc, (LPARAM)this);
}

//////////////////////////////////////////////////////////////////////
// CProgressDialog : oߕ\_CAO
//////////////////////////////////////////////////////////////////////

static const UINT wm_arcextract = ::RegisterWindowMessageA(WM_ARCEXTRACT);
static HWND s_hOwnerWnd = 0;
static LPARCHIVERPROC s_lpArcProc = NULL;

// bZ[WMEBhEݒ
BOOL CProgressDialog::SetOwnerWindow(HWND hWnd)
{
	if (s_hOwnerWnd || g_StdOut.m_hThread)
		return FALSE;
	s_hOwnerWnd = hWnd;
	return TRUE;
}

// bZ[WMR[obN֐ݒ
BOOL CProgressDialog::SetOwnerWindowEx(HWND hWnd, LPARCHIVERPROC lpArcProc)
{
	if (!SetOwnerWindow(hWnd))
		return FALSE;
	if (lpArcProc != NULL)
		s_lpArcProc = lpArcProc;
	return TRUE;
}

// I[i[EBhE
BOOL CProgressDialog::ClearOwnerWindow()
{
	if (s_hOwnerWnd == NULL || g_StdOut.m_hThread)
		return FALSE;
	s_hOwnerWnd = NULL;
	s_lpArcProc = NULL;
	return TRUE;
}

// I[i[EBhE擾
BOOL CProgressDialog::KillOwnerWindowEx(HWND hWnd)
{
	if (hWnd && hWnd != s_hOwnerWnd)
		return FALSE;
	return TRUE;
}

CProgressDialog::CProgressDialog(HWND hParentWnd)
{
	m_hWndParent = hParentWnd;
	m_nTemplateID = IDD_PROGRESS;
	m_nTotalSize = 0;
	m_bShow = FALSE;
	m_cMode = '\0';
	::ZeroMemory(&m_eis, sizeof(EXTRACTINGINFOEX));
}

BOOL CProgressDialog::DialogProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		return OnInitDialog();
	case WM_CLOSE:
		if (lParam)
		{
			if (m_bShow)
				::EnableWindow(m_hWndParent, TRUE);
			::DestroyWindow(m_hWnd);
			m_bLoopExit = TRUE;
			break;
		}
		HandlerRoutine();
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDOK:
		case IDCANCEL:
			HandlerRoutine();
			break;
		default:
			return FALSE;
		}
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

BOOL CProgressDialog::OnInitDialog()
{
	if (m_bShow)
	{
		TCHAR lpBuffer[64];
		switch (m_cMode)
		{
		case 'a':
		case 'A':
			::LoadString(g_hInstance, IDS_PROGRESS_COMPRESS, lpBuffer, 64);
			break;
		case 'e':
		case 'E':
		case 'x':
		case 'X':
			::LoadString(g_hInstance, IDS_PROGRESS_EXTRACT, lpBuffer, 64);
			break;
		case 'd':
		case 'D':
			::LoadString(g_hInstance, IDS_PROGRESS_DELETE, lpBuffer, 64);
			break;
		case 'u':
		case 'U':
			::LoadString(g_hInstance, IDS_PROGRESS_UPDATE, lpBuffer, 64);
			break;
		default:
			::ResumeThread(g_StdOut.m_hThread);
			return FALSE;
		}
		::SetWindowText(m_hWnd, lpBuffer);
		::SendDlgItemMessage(m_hWnd, IDP_PROGRESS, PBM_SETRANGE32, 0, 1000);
		MoveCenter();
		::ShowWindow(m_hWnd, SW_SHOW);
		::EnableWindow(m_hWndParent, FALSE);
	}
	::ResumeThread(g_StdOut.m_hThread);
	return FALSE;
}

// A[JCu̕\ | mode 3 M
void CProgressDialog::SetArchiveFile(LPCWSTR lpFileName)
{
	if (m_bShow)
		SetDlgItemTextW(IDS_ARCHIVE_FILE, lpFileName);
	else
	{
		if (g_StdOut.GetUnicodeMode() == TRUE)
		{
			AString strUtf8;
			::ConvertUnicodeToUTF8(lpFileName, strUtf8);
			::lstrcpynA(m_eis.exinfo.szSourceFileName, strUtf8, FNAME_MAX32);
		}
		else
			::lstrcpynA(m_eis.exinfo.szSourceFileName, ::GetOemString(lpFileName), FNAME_MAX32);
		SendExtractingInfo(ARCEXTRACT_OPEN);
	}
//	g_StdOut.SetArchiveName(lpFileName);
}

// t@C̕\ | mode 0 M
void CProgressDialog::SetWorkFile(LPCWSTR lpSourceFileName, LPCWSTR lpDestFileName)
{
	if (m_bShow)
		SetDlgItemTextW(IDS_WORK_FILE, lpSourceFileName);
	else
	{
		if (g_StdOut.GetUnicodeMode() == TRUE)
		{
			AString strUtf8;
			::ConvertUnicodeToUTF8(lpSourceFileName, strUtf8);
			::lstrcpynA(m_eis.exinfo.szSourceFileName, strUtf8, FNAME_MAX32);
			::ConvertUnicodeToUTF8(lpDestFileName, strUtf8);
			::lstrcpynA(m_eis.exinfo.szDestFileName, strUtf8, FNAME_MAX32);
		}
		else
		{
			::lstrcpynA(m_eis.exinfo.szSourceFileName, ::GetOemString(lpSourceFileName), FNAME_MAX32);
			::lstrcpynA(m_eis.exinfo.szDestFileName, ::GetOemString(lpDestFileName), FNAME_MAX32);
		}
		SendExtractingInfo(ARCEXTRACT_BEGIN);
	}
}

// is̕\ | mode 1 M
void CProgressDialog::SetCompleted(UINT64 nSize)
{
	if (m_bShow)
	{
		char lpProcessSize[64];
		sprintf(lpProcessSize, "%I64u/%I64u", nSize, m_nTotalSize);
		UINT nRatio = m_nTotalSize ? (UINT)(nSize * 1000 / m_nTotalSize) : 0;
		::SendDlgItemMessage(m_hWnd, IDP_PROGRESS, PBM_SETPOS, nRatio, 0);
		::SetDlgItemText(m_hWnd, IDS_PROCESS_SIZE, lpProcessSize);
	}
	else
	{
		if (m_eis.exinfo.dwFileSize == -1)
			m_eis.exinfo.dwWriteSize = m_nTotalSize ? (DWORD)(nSize * 1000 / m_nTotalSize) : 0;
		else
			m_eis.exinfo.dwWriteSize = (DWORD)nSize;
		SendExtractingInfo(ARCEXTRACT_INPROCESS);
	}
}

// Ŝ̃TCY\
void CProgressDialog::SetTotal(UINT64 nSize)
{
	m_nTotalSize = nSize;
	if (m_bShow)
	{
		char lpProcessSize[64];
		sprintf(lpProcessSize, "0/%I64u", nSize);
		::SetDlgItemText(m_hWnd, IDS_PROCESS_SIZE, lpProcessSize);
	}
	else
	{
		if (nSize < 0xFFFFFFFF)
			m_eis.exinfo.dwFileSize = (DWORD)nSize;
		else
			m_eis.exinfo.dwFileSize = -1;
	}
}

// t@C̃Xe[^Xݒ
void CProgressDialog::SetStatus(IInArchive *archive, UINT32 nIndex)
{
	if (m_bShow)
		return;

	NWindows::NCOM::CPropVariant propVariant;
	CMyComPtr<IInArchive> iaHandler = archive;
	if (iaHandler->GetProperty(nIndex, kpidPackedSize, &propVariant) == S_OK && propVariant.vt)
		m_eis.dwCompressedSize = ConvertPropVariantToUINT64(propVariant);
	if (iaHandler->GetProperty(nIndex, kpidCRC, &propVariant) == S_OK && propVariant.vt)
		m_eis.dwCRC = propVariant.ulVal;
	m_eis.uOSType = 0;
	m_eis.wRatio = m_nTotalSize ? m_eis.dwCompressedSize * 1000 / m_nTotalSize : 0;
	if (iaHandler->GetProperty(nIndex, kpidLastWriteTime, &propVariant) == S_OK && propVariant.vt)
	{
		FILETIME ftLocal;
		::FileTimeToLocalFileTime(&propVariant.filetime, &ftLocal);
		::FileTimeToDosDateTime(&ftLocal, &m_eis.wDate, &m_eis.wTime);
	}
	if (iaHandler->GetProperty(nIndex, kpidAttributes, &propVariant) == S_OK && propVariant.vt)
	{	
		m_eis.szAttribute[0] = (propVariant.ulVal & FILE_ATTRIBUTE_ARCHIVE)  ? 'A' : '-';
		m_eis.szAttribute[1] = (propVariant.ulVal & FILE_ATTRIBUTE_SYSTEM)   ? 'S' : '-';
		m_eis.szAttribute[2] = (propVariant.ulVal & FILE_ATTRIBUTE_HIDDEN)   ? 'H' : '-';
		m_eis.szAttribute[3] = (propVariant.ulVal & FILE_ATTRIBUTE_READONLY) ? 'R' : 'W';
//		m_eis.szAttribute[4] = (propVariant.ulVal & FA_ENCRYPTED) ? 'G' : '-';
		m_eis.szAttribute[4] = '\0';
	}
	if (iaHandler->GetProperty(nIndex, kpidMethod, &propVariant) == S_OK && propVariant.vt)
	{
		::lstrcpynA(m_eis.szMode, GetOemString(propVariant.bstrVal), 8);
		m_eis.szMode[strcspn(m_eis.szMode, " :")] = '\0';
	}
}

// I[i[EBhEɏn
void CProgressDialog::SendExtractingInfo(int nMode)
{
	if (m_bShow)
		return;

	if (s_lpArcProc)
	{
		if (s_lpArcProc(s_hOwnerWnd, wm_arcextract, nMode, nMode == 2 ? NULL : &m_eis) ==  FALSE)
			HandlerRoutine();
	}
	else if (s_hOwnerWnd)
	{
		if (::SendMessage(s_hOwnerWnd, wm_arcextract, nMode, nMode == 2 ? 0 : (LPARAM)&m_eis.exinfo))
			HandlerRoutine();
	}
}

//////////////////////////////////////////////////////////////////////
// CPasswordDialog : pX[h̓_CAO
//////////////////////////////////////////////////////////////////////

CPasswordDialog::CPasswordDialog(BOOL bMode)
{
	m_hWndParent = NULL;
	CProgressDialog* pProgDlg = g_StdOut.GetProgressDialog();
	if (pProgDlg == NULL)
		::EnumWindows(GetProcessLastActivePopup, (LPARAM)&m_hWndParent);
	else
		m_hWndParent = pProgDlg->GetBecomeParentWindow();
	m_nTemplateID = IDD_PASSWORD;
	m_bMode = bMode;
}

BOOL CPasswordDialog::DialogProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		TCHAR lpBuffer[64];
		::LoadString(g_hInstance, m_bMode ? IDS_ENCRYPT : IDS_DECRYPT, lpBuffer, 64);
		::SetWindowText(m_hWnd, lpBuffer);
		MoveCenter();
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDC_MASK:
			::SendMessage(::GetDlgItem(m_hWnd, IDE_PASSWORD), EM_SETPASSWORDCHAR,
						  ::SendMessage((HWND)lParam, BM_GETCHECK, 0, 0) == BST_CHECKED ? 0 : (WPARAM)'*', 0);
			::InvalidateRect(::GetDlgItem(m_hWnd, IDE_PASSWORD), NULL, TRUE);
			break;
		case IDOK:
			GetDlgItemTextW(IDE_PASSWORD, m_strPassword);
			::EndDialog(m_hWnd, IDOK);
			break;
		case IDCANCEL:
			::EndDialog(m_hWnd, IDCANCEL);
			break;
		default:
			return FALSE;
		}
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// CConfirmationDialog : ㏑mF_CAO
//////////////////////////////////////////////////////////////////////

CConfirmationDialog::CConfirmationDialog()
{
	m_hWndParent = g_StdOut.GetProgressDialog()->GetBecomeParentWindow();
	m_nTemplateID = IDD_CONFIRMATION;
}

BOOL CConfirmationDialog::DialogProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		{
			HINSTANCE hInst = ::LoadLibrary("SHELL32.DLL");
			if (hInst)
			{
				HICON hIcon = ::LoadIcon(hInst, MAKEINTRESOURCE(145));
				::SendMessage(::GetDlgItem(m_hWnd, IDS_REPLACE), STM_SETICON, (WPARAM)hIcon, 0);
				::FreeLibrary(hInst);
			}
			
			FILETIME ftLocal;
			SYSTEMTIME stWrite;
			TCHAR lpFormat[128];
			UString strFileInfo;
			SHFILEINFOA shFileInfo;
			SHFILEINFOW shFileInfoW;
			
			::FileTimeToLocalFileTime(&m_ftNewWrite, &ftLocal);
			::FileTimeToSystemTime(&ftLocal, &stWrite);
			::GetDlgItemText(m_hWnd, IDS_NEW_FILE_INFO, lpFormat, 128);
			swprintf(strFileInfo.GetBuffer(m_strNewName.Length() + 128), (LPCWSTR)GetUnicodeString(lpFormat), (LPCWSTR)m_strNewName, stWrite.wYear, stWrite.wMonth, stWrite.wDay, stWrite.wHour, stWrite.wMinute, stWrite.wSecond, m_nNewSize);
			strFileInfo.ReleaseBuffer();
			if (g_bIsNT)
				::SHGetFileInfoW(m_strNewName, FILE_ATTRIBUTE_NORMAL, &shFileInfoW, sizeof(shFileInfoW), SHGFI_ICON | SHGFI_USEFILEATTRIBUTES | SHGFI_LARGEICON);
			else
				::SHGetFileInfoA(GetOemString(m_strNewName), FILE_ATTRIBUTE_NORMAL, &shFileInfo, sizeof(shFileInfo), SHGFI_ICON | SHGFI_USEFILEATTRIBUTES | SHGFI_LARGEICON);
			::SendMessage(::GetDlgItem(m_hWnd, IDS_NEW_ICON), STM_SETICON, (WPARAM)(g_bIsNT ? shFileInfoW.hIcon : shFileInfo.hIcon), 0);
			SetDlgItemTextW(IDS_NEW_FILE_INFO, strFileInfo);
			
			::FileTimeToLocalFileTime(&m_ftOldWrite, &ftLocal);
			::FileTimeToSystemTime(&ftLocal, &stWrite);
			::GetDlgItemText(m_hWnd, IDS_OLD_FILE_INFO, lpFormat, 128);
			swprintf(strFileInfo.GetBuffer(m_strOldName.Length() + 128), (LPCWSTR)GetUnicodeString(lpFormat), (LPCWSTR)m_strOldName, stWrite.wYear, stWrite.wMonth, stWrite.wDay, stWrite.wHour, stWrite.wMinute, stWrite.wSecond, m_nOldSize);
			strFileInfo.ReleaseBuffer();
			if (g_bIsNT)
				::SHGetFileInfoW(m_strOldName, FILE_ATTRIBUTE_NORMAL, &shFileInfoW, sizeof(shFileInfoW), SHGFI_ICON | SHGFI_USEFILEATTRIBUTES | SHGFI_LARGEICON);
			else
				::SHGetFileInfoA(GetOemString(m_strOldName), FILE_ATTRIBUTE_NORMAL, &shFileInfo, sizeof(shFileInfo), SHGFI_ICON | SHGFI_USEFILEATTRIBUTES | SHGFI_LARGEICON);
			::SendMessage(::GetDlgItem(m_hWnd, IDS_OLD_ICON), STM_SETICON, (WPARAM)(g_bIsNT ? shFileInfoW.hIcon : shFileInfo.hIcon), 0);
			SetDlgItemTextW(IDS_OLD_FILE_INFO, strFileInfo);

			MoveCenter();
			return TRUE;
		}
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDB_YES:
		case IDB_NO:
		case IDB_YES_ALL:
		case IDB_NO_ALL:
		case IDB_AUTO_RENAME:
		case IDCANCEL:
			::EndDialog(m_hWnd, (int)LOWORD(wParam));
			break;
		default:
			return FALSE;
		}
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

// t@C̐ݒ
void CConfirmationDialog::SetFileInfo(LPCWSTR lpNewName, UINT64 nNewSize, const FILETIME &ftNewWrite, LPCWSTR lpOldName, UINT64 nOldSize, const FILETIME &ftOldWrite)
{
	::NWindows::NFile::NDirectory::MyGetFullPathName(lpOldName, m_strOldName);
	m_strNewName = lpNewName;
	m_nNewSize = nNewSize;
	m_nOldSize = nOldSize;
	m_ftNewWrite = ftNewWrite;
	m_ftOldWrite = ftOldWrite;
}

//////////////////////////////////////////////////////////////////////
// CConfigDialog : ݒ_CAO
//////////////////////////////////////////////////////////////////////

CConfigDialog::CConfigDialog(HWND hParentWnd)
{
	m_hWndParent = hParentWnd;
	m_nTemplateID = IDD_CONFIG;
}

BOOL CConfigDialog::DialogProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		{
			TCHAR lpVersion[64];
			::wsprintf(lpVersion, _T("7-zip32.dll version %d.%.2d.%.2d.%.2d"), ::SevenZipGetVersion() / 100, ::SevenZipGetVersion() % 100, ::SevenZipGetSubVersion() / 100, ::SevenZipGetSubVersion() % 100);
			::SetDlgItemText(m_hWnd, IDS_VERSION, lpVersion);
			MoveCenter();
		}
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDOK:
		case IDCANCEL:
			::EndDialog(m_hWnd, LOWORD(wParam));
			break;
		default:
			return FALSE;
		}
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// CSfxDialog : SFX쐬_CAO
//////////////////////////////////////////////////////////////////////

CSfxDialog::CSfxDialog(HWND hParentWnd)
{
	m_hWndParent = hParentWnd;
	m_nTemplateID = IDD_SFX;
}

BOOL CSfxDialog::DialogProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		MoveCenter();
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDOK:
			{
				FILE *stream;
				UString strName = g_StdOut.GetTempSFXName();
				stream = g_bIsNT ? _wfopen(strName, L"wb") : fopen(GetOemString(strName), "wb");

				HRSRC hResInfo = ::FindResource(g_hInstance, MAKEINTRESOURCE(IDR_7ZSDJC), "SFX");
				HGLOBAL hResData = ::LoadResource(g_hInstance, hResInfo);
				DWORD dwSize = ::SizeofResource(g_hInstance, hResInfo);
				LPVOID lpBuffer = ::LockResource(hResData);
				fwrite(lpBuffer, sizeof(char), dwSize, stream);

				UString strText;
				AString utfString = ";!@Install@!UTF-8!\r\n";
				fwrite((const char*)utfString, sizeof(char), utfString.Length(), stream);
				GetDlgItemTextW(IDE_TITLE, strText);
				if (!strText.IsEmpty())
				{
					ConvertUnicodeToUTF8(strText, utfString);
					utfString = "Title=\"" + utfString + "\"\r\n";
					fwrite((const char*)utfString, sizeof(char), utfString.Length(), stream);
				}
				GetDlgItemTextW(IDE_BEGIN_PROMPT, strText);
				if (!strText.IsEmpty())
				{
					ConvertUnicodeToUTF8(strText, utfString);
					utfString = "BeginPrompt=\"" + utfString + "\"\r\n";
					fwrite((const char*)utfString, sizeof(char), utfString.Length(), stream);
				}
				GetDlgItemTextW(IDE_RUN_PROGRAM, strText);
				if (!strText.IsEmpty())
				{
					ConvertUnicodeToUTF8(strText, utfString);
					utfString = "RunProgram=\"" + utfString + "\"\r\n";
					fwrite((const char*)utfString, sizeof(char), utfString.Length(), stream);
				}
				utfString = ";!@InstallEnd@!";
				fwrite((const char*)utfString, sizeof(char), utfString.Length(), stream);

				fclose(stream);

			}
		case IDCANCEL:
			::EndDialog(m_hWnd, LOWORD(wParam));
			break;
		default:
			return FALSE;
		}
		break;
	default:
		return FALSE;
	}
	return TRUE;
}
